/*
Copyright 2009 Ramnivas Laddad

Licensed under the Apache License, Version 2.0 (the "License"); 
you may not use this file except in compliance with the License. 
You may obtain a copy of the License at 
    http://www.apache.org/licenses/LICENSE-2.0 

Unless required by applicable law or agreed to in writing, software 
distributed under the License is distributed on an "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
See the License for the specific language governing permissions and 
limitations under the License. 
*/

package ajia.transaction;

import org.springframework.transaction.TransactionDefinition;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.PlatformTransactionManager;

public aspect TransactionPointcuts {
	public pointcut transactionBegin(TransactionDefinition txDefinition)
	    : execution(* PlatformTransactionManager.*(TransactionDefinition))
	      && args(txDefinition);

	public pointcut transactionEnd(TransactionStatus txStatus)
	    : execution(* PlatformTransactionManager.*(TransactionStatus))
	      && args(txStatus);

	public pointcut transactionalExecution()
	    : execution(@Transactional * *(..))
	      || execution(* (@Transactional *).*(..));
}